# How to Python in computational neuroscience, data mining, and more 
{:.no_toc}

<nav markdown="1" class="toc-class">
* TOC
{:toc}
</nav>

All the tutorials are tested with Python 3.11.x. Older version might have a problem with the new versions of type anotations. 

## Python: The Basics of the basics
* [Hello, Python](python_basics/hello_python/README.md)
* [Style Rulez](python_basics/style_rulez/README.md)
* [Programming Recommendations](python_basics/programming_recommendations/README.md)
* [Basic Math Operations](python_basics/basic_math_operations/README.md)
* [Truth Value Testing](python_basics/truth_value_testing/README.md)
* [Formatted String Literals](python_basics/formatted_string_literals/README.md)
* [Flow Control Overview](python_basics/flow_control_overview/README.md)
* [Flow control: match case](python_basics/match/README.md)
* [Files](python_basics/files/README.md)
* [Creating order via sub-directories: os.makedirs](python_basics/os_makedirs/README.md)
* [Finding files in a directory: glob](python_basics/glob/README.md)
* [Class](python_basics/class/README.md)
* [Exceptions](python_basics/exceptions/README.md)


## Numpy
* [Beyond normal np.save](numpy_save_special/README.md)
* [Dealing with Matlab files](numpy_mat_files/README.md)

## Python: Data analysis

* [Numpy: Random numbers the non-legacy way](numpy_random/README.md)
* [Remove a common signal from your data](SVD_data_cleaning/README.md)

## Python: Questions of spectral nature

* [Numpy: rfft and spectral power](numpy_fft_1/README.md)
* [scipy.signal: Butterworth low, high and band-pass](scipy.signal_butterworth/README.md)
* [PyWavelets: Wavelet Transforms in Python](pywavelet/README.md)


## Python: Daily little helper

* [TQDM: Make your progress visible](TQDM/README.md)

## PyTorch 
* [Layers](pytorch/layers/README.md)

## Matlab: Basics
* [Basic Structure of a Computer](matlab/1/README.md)
* [Representation of Numbers in the Computer](matlab/2/README.md)

Note: I will transfer [https://www.neurotec.uni-bremen.de/drupal/teaching](https://www.neurotec.uni-bremen.de/drupal/teaching) to this new place (and update it). 
